/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.protokollierung.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="PROTOKOLL_EINTRAG.All",
     query="SELECT o FROM ProtokollEintrag o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="PROTOKOLL_EINTRAG.EntitaetPrimaerschluesselAbZeitpunkt",
     query="SELECT o FROM ProtokollEintrag o WHERE o.entitaet = ?1 AND o.primaerschluessel = ?2 AND o.zeitpunkt >= ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "PROTOKOLL_EINTRAG")
// @javax.persistence.IdClass(ProtokollEintragPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    
public
 class ProtokollEintrag
extends AbstractProtokollEintrag
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public ProtokollEintrag() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public ProtokollEintrag(ProtokollEintrag original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "protokoll_eintrag_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "ProtokollEintrag")
    @javax.persistence.TableGenerator(name = "ProtokollEintrag", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "ProtokollEintrag", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient ProtokollEintragPK pkCache;

  @Override
  public ProtokollEintragPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new ProtokollEintragPK(getId());
    }

    return pkCache;
  }

  public static <E extends ProtokollEintrag> java.util.Map<ProtokollEintragPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<ProtokollEintragPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends ProtokollEintrag> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedAlterWert = false;
          hasChangedAttribut = false;
          hasChangedAttributTyp = false;
          hasChangedBenutzerkennung = false;
          hasChangedEntitaet = false;
          hasChangedNeuerWert = false;
          hasChangedPrimaerschluessel = false;
          hasChangedProtokollEintragArt = false;
          hasChangedZeitpunkt = false;
  



    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "ALTER_WERT", nullable = ProtokollEintragConstants.ALTER_WERT_NULLABLE, length=ProtokollEintragConstants.ALTER_WERT_MAX_LENGTH)
        
  protected java.lang.String alterWert =  null;

  @javax.persistence.Transient
  protected boolean hasChangedAlterWert = false;

  public boolean hasChangedAlterWert(){
    return hasChangedAlterWert;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.ALTER_WERT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getAlterWert() {
        return alterWert;
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.ALTER_WERT
   *
   * @param alterWert
   */
  @Override   public void setAlterWert(@javax.annotation.Nullable  java.lang.String alterWert) {

       resetTkCache();
                  
                          java.lang.String alterWertInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(alterWert, ProtokollEintragConstants.ALTER_WERT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.alterWert
      , alterWertInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAlterWert |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("alterWert");
      }


      

       this.alterWert = alterWertInternal;

         }

        
  @javax.persistence.Column(name = "ATTRIBUT", nullable = ProtokollEintragConstants.ATTRIBUT_NULLABLE, length=ProtokollEintragConstants.ATTRIBUT_MAX_LENGTH)
        
  protected java.lang.String attribut =  null;

  @javax.persistence.Transient
  protected boolean hasChangedAttribut = false;

  public boolean hasChangedAttribut(){
    return hasChangedAttribut;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.ATTRIBUT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getAttribut() {
        return attribut;
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.ATTRIBUT
   *
   * @param attribut
   */
  @Override   public void setAttribut(@javax.annotation.Nullable  java.lang.String attribut) {

       resetTkCache();
                  
                          java.lang.String attributInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(attribut, ProtokollEintragConstants.ATTRIBUT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.attribut
      , attributInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAttribut |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("attribut");
      }


      

       this.attribut = attributInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ATTRIBUT_TYP", nullable = ProtokollEintragConstants.ATTRIBUT_TYP_NULLABLE)
    
  protected de.ivu.elect.jee.protokollierung.AttributTyp attributTyp =  null;

  @javax.persistence.Transient
  protected boolean hasChangedAttributTyp = false;

  public boolean hasChangedAttributTyp(){
    return hasChangedAttributTyp;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.ATTRIBUT_TYP
   */
    @Override   public  de.ivu.elect.jee.protokollierung.AttributTyp getAttributTyp() {
        return attributTyp;
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.ATTRIBUT_TYP
   *
   * @param attributTyp
   */
  @Override   public void setAttributTyp( de.ivu.elect.jee.protokollierung.AttributTyp attributTyp) {

       resetTkCache();
                  de.ivu.elect.jee.protokollierung.AttributTyp attributTypInternal = attributTyp;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.attributTyp
      , attributTypInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAttributTyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("attributTyp");
      }


      

       this.attributTyp = attributTypInternal;

         }

        
      @javax.persistence.Column(name = "BENUTZERKENNUNG", nullable = ProtokollEintragConstants.BENUTZERKENNUNG_NULLABLE, length=ProtokollEintragConstants.BENUTZERKENNUNG_MAX_LENGTH)
        
  protected java.lang.String benutzerkennung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBenutzerkennung = false;

  public boolean hasChangedBenutzerkennung(){
    return hasChangedBenutzerkennung;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.BENUTZERKENNUNG
   */
    @Override   public  java.lang.String getBenutzerkennung() {
        return benutzerkennung;
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.BENUTZERKENNUNG
   *
   * @param benutzerkennung
   */
  @Override   public void setBenutzerkennung( java.lang.String benutzerkennung) {

       resetTkCache();
                  
                          java.lang.String benutzerkennungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(benutzerkennung, ProtokollEintragConstants.BENUTZERKENNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.benutzerkennung
      , benutzerkennungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBenutzerkennung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("benutzerkennung");
      }


      

       this.benutzerkennung = benutzerkennungInternal;

         }

        
      @javax.persistence.Column(name = "ENTITAET", nullable = ProtokollEintragConstants.ENTITAET_NULLABLE, length=ProtokollEintragConstants.ENTITAET_MAX_LENGTH)
        
  protected java.lang.String entitaet =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEntitaet = false;

  public boolean hasChangedEntitaet(){
    return hasChangedEntitaet;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.ENTITAET
   */
    @Override   public  java.lang.String getEntitaet() {
        return entitaet;
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.ENTITAET
   *
   * @param entitaet
   */
  @Override   public void setEntitaet( java.lang.String entitaet) {

       resetTkCache();
                  
                          java.lang.String entitaetInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(entitaet, ProtokollEintragConstants.ENTITAET_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.entitaet
      , entitaetInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEntitaet |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("entitaet");
      }


      

       this.entitaet = entitaetInternal;

         }

        
  @javax.persistence.Column(name = "NEUER_WERT", nullable = ProtokollEintragConstants.NEUER_WERT_NULLABLE, length=ProtokollEintragConstants.NEUER_WERT_MAX_LENGTH)
        
  protected java.lang.String neuerWert =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNeuerWert = false;

  public boolean hasChangedNeuerWert(){
    return hasChangedNeuerWert;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.NEUER_WERT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getNeuerWert() {
        return neuerWert;
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.NEUER_WERT
   *
   * @param neuerWert
   */
  @Override   public void setNeuerWert(@javax.annotation.Nullable  java.lang.String neuerWert) {

       resetTkCache();
                  
                          java.lang.String neuerWertInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(neuerWert, ProtokollEintragConstants.NEUER_WERT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.neuerWert
      , neuerWertInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNeuerWert |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("neuerWert");
      }


      

       this.neuerWert = neuerWertInternal;

         }

        
      @javax.persistence.Column(name = "PRIMAERSCHLUESSEL", nullable = ProtokollEintragConstants.PRIMAERSCHLUESSEL_NULLABLE, precision=ProtokollEintragConstants.PRIMAERSCHLUESSEL_PRECISION, scale=ProtokollEintragConstants.PRIMAERSCHLUESSEL_SCALE)
            
  protected java.lang.Long primaerschluessel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPrimaerschluessel = false;

  public boolean hasChangedPrimaerschluessel(){
    return hasChangedPrimaerschluessel;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.PRIMAERSCHLUESSEL
   */
    @Override   public  java.lang.Long getPrimaerschluessel() {
        return primaerschluessel;
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.PRIMAERSCHLUESSEL
   *
   * @param primaerschluessel
   */
  @Override   public void setPrimaerschluessel( java.lang.Long primaerschluessel) {

       resetTkCache();
                  java.lang.Long primaerschluesselInternal = primaerschluessel;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.primaerschluessel
      , primaerschluesselInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPrimaerschluessel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("primaerschluessel");
      }


      

       this.primaerschluessel = primaerschluesselInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PROTOKOLL_EINTRAG_ART", nullable = ProtokollEintragConstants.PROTOKOLL_EINTRAG_ART_NULLABLE)
    
  protected de.ivu.elect.jee.protokollierung.ProtokollEintragArt protokollEintragArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedProtokollEintragArt = false;

  public boolean hasChangedProtokollEintragArt(){
    return hasChangedProtokollEintragArt;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.PROTOKOLL_EINTRAG_ART
   */
    @Override   public  de.ivu.elect.jee.protokollierung.ProtokollEintragArt getProtokollEintragArt() {
        return protokollEintragArt;
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.PROTOKOLL_EINTRAG_ART
   *
   * @param protokollEintragArt
   */
  @Override   public void setProtokollEintragArt( de.ivu.elect.jee.protokollierung.ProtokollEintragArt protokollEintragArt) {

       resetTkCache();
                  de.ivu.elect.jee.protokollierung.ProtokollEintragArt protokollEintragArtInternal = protokollEintragArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.protokollEintragArt
      , protokollEintragArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedProtokollEintragArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("protokollEintragArt");
      }


      

       this.protokollEintragArt = protokollEintragArtInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ZEITPUNKT", nullable = ProtokollEintragConstants.ZEITPUNKT_NULLABLE, precision=ProtokollEintragConstants.ZEITPUNKT_PRECISION)
    
  protected java.util.Date zeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZeitpunkt = false;

  public boolean hasChangedZeitpunkt(){
    return hasChangedZeitpunkt;
  }
  
  /**
   * 
   *
   * getter for PROTOKOLL_EINTRAG.ZEITPUNKT
   */
    @Override   public  java.util.Date getZeitpunkt() {
              if (zeitpunkt == null){
            return null;
          } else {
                          return zeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for PROTOKOLL_EINTRAG.ZEITPUNKT
   *
   * @param zeitpunkt
   */
  @Override   public void setZeitpunkt( java.util.Date zeitpunkt) {

       resetTkCache();
                  java.util.Date zeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(zeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zeitpunkt
      , zeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zeitpunkt");
      }


      

       this.zeitpunkt = zeitpunktInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("ProtokollEintrag:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(ProtokollEintrag other){
                             other.alterWert = this.alterWert;
                                other.attribut = this.attribut;
                                other.attributTyp = this.attributTyp;
                                other.benutzerkennung = this.benutzerkennung;
                                other.entitaet = this.entitaet;
                                other.neuerWert = this.neuerWert;
                                other.primaerschluessel = this.primaerschluessel;
                                other.protokollEintragArt = this.protokollEintragArt;
                                other.zeitpunkt = this.zeitpunkt;
           


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(ProtokollEintrag.class)){
        copyEntityAttributesUsingSetter((ProtokollEintrag) other.castTo(ProtokollEintrag.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von ProtokollEintrag: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(ProtokollEintrag other){
               other.setAlterWert(this.alterWert);
                  other.setAttribut(this.attribut);
                  other.setAttributTyp(this.attributTyp);
                  other.setBenutzerkennung(this.benutzerkennung);
                  other.setEntitaet(this.entitaet);
                  other.setNeuerWert(this.neuerWert);
                  other.setPrimaerschluessel(this.primaerschluessel);
                  other.setProtokollEintragArt(this.protokollEintragArt);
                  other.setZeitpunkt(this.zeitpunkt);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(ProtokollEintrag other){
                       if (hasChangedAlterWert) {
        other.setAlterWert(this.alterWert);
      }
                             if (hasChangedAttribut) {
        other.setAttribut(this.attribut);
      }
                             if (hasChangedAttributTyp) {
        other.setAttributTyp(this.attributTyp);
      }
                             if (hasChangedBenutzerkennung) {
        other.setBenutzerkennung(this.benutzerkennung);
      }
                             if (hasChangedEntitaet) {
        other.setEntitaet(this.entitaet);
      }
                             if (hasChangedNeuerWert) {
        other.setNeuerWert(this.neuerWert);
      }
                             if (hasChangedPrimaerschluessel) {
        other.setPrimaerschluessel(this.primaerschluessel);
      }
                             if (hasChangedProtokollEintragArt) {
        other.setProtokollEintragArt(this.protokollEintragArt);
      }
                             if (hasChangedZeitpunkt) {
        other.setZeitpunkt(this.zeitpunkt);
      }
             }





    @javax.persistence.Transient
    private transient ProtokollEintragTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public ProtokollEintragTK getProtokollEintragTK(){
    if (tkCache==null) {
    tkCache = new ProtokollEintragTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getProtokollEintragTK();
    }

  @Override
  public ProtokollEintragUK getUk(){
    return getProtokollEintragUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return ProtokollEintrag.class;
  }

public ProtokollEintragUK getProtokollEintragUK(){

   return  new ProtokollEintragUK(



  );
}

  @javax.persistence.Transient
  private transient ProtokollEintragProperties properties;

  public ProtokollEintragProperties getProperties(){
    if (properties == null) {
      properties = new ProtokollEintragProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ProtokollEintragProperties getProtokollEintragProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ProtokollEintragConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                                                                 }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                                                                                                                                                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                                                                                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "PROTOKOLL_EINTRAG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "ProtokollEintrag";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ProtokollEintragConstants.ALTER_WERT_MAX_LENGTH ,  alterWert, this, ProtokollEintragConstants.MESSAGE_KEY_ALTER_WERT_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ProtokollEintragConstants.ATTRIBUT_MAX_LENGTH ,  attribut, this, ProtokollEintragConstants.MESSAGE_KEY_ATTRIBUT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(attributTyp, this, ProtokollEintragConstants.MESSAGE_KEY_ATTRIBUT_TYP_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(benutzerkennung, this, ProtokollEintragConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ProtokollEintragConstants.BENUTZERKENNUNG_MAX_LENGTH , 1 ,  benutzerkennung, this, ProtokollEintragConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(entitaet, this, ProtokollEintragConstants.MESSAGE_KEY_ENTITAET_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ProtokollEintragConstants.ENTITAET_MAX_LENGTH , 1 ,  entitaet, this, ProtokollEintragConstants.MESSAGE_KEY_ENTITAET_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ProtokollEintragConstants.NEUER_WERT_MAX_LENGTH ,  neuerWert, this, ProtokollEintragConstants.MESSAGE_KEY_NEUER_WERT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(primaerschluessel, this, ProtokollEintragConstants.MESSAGE_KEY_PRIMAERSCHLUESSEL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(ProtokollEintragConstants.PRIMAERSCHLUESSEL_MAX_VALUE, ProtokollEintragConstants.PRIMAERSCHLUESSEL_MIN_VALUE, primaerschluessel, this, ProtokollEintragConstants.MESSAGE_KEY_PRIMAERSCHLUESSEL_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(protokollEintragArt, this, ProtokollEintragConstants.MESSAGE_KEY_PROTOKOLL_EINTRAG_ART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(zeitpunkt, this, ProtokollEintragConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
